typedef unsigned char	byte;
typedef unsigned short	word;
typedef unsigned int	uint;



void InvertIdeaKey (word* key, word* invKey);
void ExpandUserKey(word* userKey, word* key);
void idea_cipher (word* in, word* out, word* key);
word mul (word first, word second);
word mulInv (word x);


byte KeyEnc[104];
byte KeyDec[104];


//       
// /    ,
//    CrypTool   ...
byte Key0[]		= { 0x7B,0x00,0x6F,0x00,0x0A,0x00,0x0C,0x00,0xDE,0x00,0x5A,0x00,0x01,0x00,0x08,0x00	};
byte EncData0[]	= { 0xDB,0x42,0xA3,0xC5,0x1F,0xD7,0xCE,0x05	};		//    
byte DecData0[]	= { 0x78,0x9C,0xBD,0x7D,0x09,0x7C,0x1B,0xC7	};		//   -  zLib 


//         DCPCrypt - dcpidea.pas
// /     
//    CrypTool    
byte Key1[]		= { 0x3A,0x98,0x4E,0x20,0x00,0x19,0x5D,0xB3,0x2E,0xE5,0x01,0xC8,0xC4,0x7C,0xEA,0x60	};
byte DecData1[]	= { 0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08	};
byte EncData1[]	= { 0x97,0xBC,0xD8,0x20,0x07,0x80,0xDA,0x86	};

byte Key2[]		= { 0x00,0x64,0x00,0xC8,0x01,0x2C,0x01,0x90,0x01,0xF4,0x02,0x58,0x02,0xBC,0x03,0x20	};
byte DecData2[]	= { 0x05,0x32,0x0A,0x64,0x14,0xC8,0x19,0xFA	};
byte EncData2[]	= { 0x65,0xBE,0x87,0xE7,0xA2,0x53,0x8A,0xED	};



/*
ukey	7B006F000A000C00DE005A0001000800
data	789CBD7D097C1BC779EFECE220414AF2
result	DB42A3C51FD7CE05B1546CEE6CFFEF66
*/



int main ()
{
	word buffer[4];

	ExpandUserKey ((word*)&Key0, (word*)&KeyEnc);
	InvertIdeaKey ((word*)&KeyEnc, (word*)&KeyDec);
	idea_cipher ((word*)&EncData0, buffer, (word*)&KeyDec);

	ExpandUserKey ((word*)&Key1, (word*)&KeyEnc);
	InvertIdeaKey ((word*)&KeyEnc, (word*)&KeyDec);
	idea_cipher ((word*)&EncData1, buffer, (word*)&KeyDec);

return 0;
}



//    128  832 
void ExpandUserKey(word* userKey, word* key)
{
	for(int i = 0; i < 8; i++) key[i] = userKey[i];

	for(int i = 8; i < 52; i++)
	{
		if ((i + 2) % 8 == 0)
			key[i] = (word)(((key[i-7]&127)<<9)|(key[i-14]>>7));
		else if ((i + 1) % 8 == 0)
			key[i] = (word)(((key[i-15]&127)<<9)|(key[i-14]>>7));
		else
		key[i] = (word)(((key[i-7]&127)<<9)|(key[i-6]>>7));
	}
}



void InvertIdeaKey (word* key, word* invKey)
{
	word buf[52];
	buf[48] = mulInv (*(key++));
	buf[49] = (-*(key++));
	buf[50] = (-*(key++));
	buf[51] = mulInv (*(key++));

	for (int i = 42; i >= 0; i -= 6)
	{
		buf[i+4] = *(key++);
		buf[i+5] = *(key++);
		buf[i] = mulInv (*(key++));

		if(i > 0)
		{
			buf[i+2] = (-*(key++));
			buf[i+1] = (-*(key++));
		}
		else
		{
			buf[i+1] = (-*(key++));
			buf[i+2] = (-*(key++));
		}
		buf[i+3] = mulInv (*(key++));
	}

	for (int i = 0; i < 52; i++) invKey[i] = buf[i];
}



//  /   -    ( )
void idea_cipher (word* input, word* output, word* key)
{
	int x, y;

	word buf[4] = {input[0], input[1], input[2], input[3]};

	for (int i = 0; i < 8; i++)
	{
		buf[0] = mul (buf[0], *(key++));
		buf[1] += *(key++);
		buf[2] += *(key++);
		buf[3] = mul (buf[3], *(key++));

		x = mul ((buf[0] ^ buf[2]), *(key++));
		y = mul (((buf[1] ^ buf[3]) + x), *(key++));
		x += y;

		buf[0] ^= y;
		buf[3] ^= x;
		x ^= buf[1];
		buf[1] = buf[2] ^ y;
		buf[2] = x;
	}

	output[0] = mul (buf[0], *(key++));
	output[1] = buf[2] + *(key++);
	output[2] = buf[1] + *(key++);
	output[3] = mul (buf[3], *(key));

return;
}



word mul (word first, word second)
{
	if (!first)	return (1 - second);
	else if (!second) return (1 - first);
	else
	{
		uint prod = first * second;
		int p = (prod & 0xFFFF) - (prod >> 16);
	
		if (p <= 0) p++;

	return p;
	}
}



word mulInv (word x)
{
	int rest, divisor, t;
	if (!x) return 0;

	int num1 = 0x10001, num2 = x, b1 = 0, b2 = 1;

	do
	{
		rest = num1 % num2;

//   ?
//      ,   
//		divisor = (num1 - rest) / num2;
		divisor = num1 / num2;

		if (!rest) {if (b2 < 0) {b2 += 0x10001;}}
		else
		{
    		num1 = num2;
      		num2 = rest;
      		t = b2;
      		b2 = b1 - divisor * b2;
      		b1 = t;
    	}
	}
	while (rest);

return b2;
}
